module Queue1b where

newtype Queue a = MkQ [a]

empty :: Queue a
empty = MkQ []

isEmpty :: Queue a -> Bool
isEmpty (MkQ xs) = null xs

join :: a -> Queue a -> Queue a
join x (MkQ xs) = MkQ (xs ++ [x])

front :: Queue a -> a
front (MkQ (x:xs)) = x

back :: Queue a -> Queue a
back (MkQ (x:xs)) = MkQ xs


-- compQ = ((join 1 . join 2 $ empty) == (join 2 . join 1 $ empty))

instance Show a => Show (Queue a) where	show (MkQ (xs)) = show (xs)